<template>
  <div>
    <el-dialog
      title="批量调整积分"
      custom-class="customer-dialog"
      :visible.sync="visible"
      :close-on-click-modal="false"
      @close="cancel"
      width="600px"
    >
      <div class="checkedCustomers">
        当前选中<span class="num">
          {{ selectObj.selectAll?selectObj.totalCount:selectObj.multipleList.length }} </span>位客户
      </div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="133px"
      >
        <el-form-item label="调整积分：" prop="editType">
          <el-radio-group v-model="form.editType">
            <el-radio :label="1">
              增加积分
            </el-radio>
            <el-radio :label="2">
              扣除积分
            </el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="调整额度：" prop="accumulatPoints">
          <el-input-number
            v-model="form.accumulatPoints"
            style="width: 115px;"
            controls-position="right"
            :min="1"
            :max="999999"
          />
        </el-form-item>
        <el-form-item
          label="原始成本主体："
          prop="settlementStoreId"
          v-if="integralFlag == 'gic' && form.editType == 1"
        >
          <el-select
            prop="settlementStoreId"
            style="width: 400px;"
            v-model="form.settlementStoreId"
            filterable
            remote
            reserve-keyword
            placeholder="请输入门店名称/门店code"
            :remote-method="getStoreCodeName"
            :loading="loading"
          >
            <el-option
              v-for="item in storeList"
              :key="item.storeId"
              :label="item.storeName"
              :value="item.storeId"
            />
          </el-select>
          <p class="sub-tip">
            注：除输入选择具体门店外，还可输入总部，记总部名下
          </p>
        </el-form-item>
        <el-form-item label="原因备注：" prop="remark">
          <el-input
            type="text"
            maxlength="20"
            show-word-limit
            v-model="form.remark"
            placeholder="请输入内容"
            style="width: 400px;"
          />
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" :loading="btnLoading" @click="submit">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import { doFetch, doFetchqs } from '../../axios/api';
import url from '../../axios/url';
import { checkFalse, checkStatus, checkSuccess } from '../../../../static/js/checkStatus';
export default {
  name: 'IntegralDailog',
  props: {
    dialogVisible: {
      type: Boolean,
      default: false,
    },
    ajaxObj: {
      type: Object,
      default: () => {
        return {
          pageName: '',
        };
      },
    },
    selectObj: {
      type: Object,
      default: () => {
        return {
          totalCount: 0,
          selectAll: false,
          multipleList: [],
        };
      },
    },
    integralFlag: {
      type: String,
      default: '',
    },
  },
  data () {
    return {
      visible: false,
      form: {
        editType: 1,
        accumulatPoints: 0,
        remark: '',
        settlementStoreId: '',
      },
      rules: {
        editType: [
          { required: true, message: '请选择调整方式', trigger: 'change' },
        ],
        accumulatPoints: [
          { required: true, message: '请选择调整额度', trigger: 'change' },
        ],
        remark: [
          { required: true, message: '请输入原因备注', trigger: 'change' },
        ],
        settlementStoreId: [
          { required: true, message: '请填写原始成本主体', trigger: 'change' },
        ],
      },
      btnLoading: false,
      loading: false,
      storeList: [],
    };
  },
  watch: {
    dialogVisible (n, o) {
      this.visible = n;
    },
  },
  methods: {
    cancel () {
      this.$refs.form.resetFields();
      this.$emit('update:dialogVisible', false);
    },
    getStoreCodeName (val) {
      this.loading = true;
      doFetchqs(url.storeCodeName, {
        searchParam: val,
        flag: 1,
      })
        .then(res => {
          if (res.data.errorCode === 0) {
            this.storeList = res.data.result;
          } else {
            checkFalse(res.data.message);
          }
        })
        .catch(err => {
          checkStatus(err);
        }).finally(_ => (this.loading = false));
    },
    submit () {
      this.$refs.form.validate(valid => {
        if (valid) {
          const { selectAll, multipleList } = this.selectObj;
          const { memberSearchStr, pageSize, phoneNameCard, pageName } = this.ajaxObj;
          this.btnLoading = true;
          const memberIdsArr = [];
          multipleList.forEach(item => {
            memberIdsArr.push(item.memberId);
          });
          doFetch(url.updateIntegrals, Object.assign({}, this.form, {
            memberIds: selectAll == true ? '-1' : memberIdsArr.join(','),
            isCurrent: selectAll == true ? 2 : multipleList.length == pageSize ? 1 : 0,
            memberSearchParamStr: selectAll == true ? (memberSearchStr || '-1') : '',
            phoneNameCard: phoneNameCard,
            pageName: pageName,
          }))
            .then(res => {
              console.log(res);
              if (res.data.errorCode === 0) {
                checkSuccess('');
                this.$refs.form.resetFields();
                this.$emit('update:dialogVisible', false);
                this.$emit('successImport', res.data.result);
                this.$emit('refresh');
              } else {
                checkFalse();
              }
            })
            .catch(err => {
              checkStatus(err);
            }).finally(_ => (this.btnLoading = false));
        } else {
          return false;
        }
      });
    },
  },
};

</script>
<style lang="less" scoped>
.customer-dialog {
  .checkedCustomers {
    margin-left: 133px;
    margin-bottom: 20px;
    font-size: 14px;
    font-weight: 400;
    color: #909399;
    line-height: 20px;
    .num {
      color: #303133;
    }
  }
  .sub-tip {
    margin: 4px 0 -5px;
    font-size: 12px;
    font-weight: 400;
    color: #909399;
    line-height: 17px;
  }
}
</style>
